#lang racket
(require rackunit)
(require "stream.rkt")
(require "stream-map.rkt")
(require "naturals.rkt")
(provide even-naturals)

(define (even-naturals)
  (stream-map
    (curry * 2)
    (naturals)))

(define s1 (even-naturals))
(check-equal? 0 (stream-get s1))

(define s2 (stream-next s1))
(check-equal? 2 (stream-get s2))

(define s3 (stream-next s2))
(check-equal? 4 (stream-get s3))
