#lang racket
(provide naturals)

(require "stream.rkt")
(require rackunit)
(define (naturals)
  (define (naturals-iter n)
    (thunk
      (cons n (naturals-iter (+ n 1)))))
  ((naturals-iter 0)))

(define s0 (naturals))
(check-equal? 0 (stream-get s0))

(define s1 (stream-next s0))
(check-equal? 1 (stream-get s1))

(define s2 (stream-next s1))
(check-equal? 2 (stream-get s2))

