#lang racket
(provide (all-defined-out))

; Retrieves the current value of the stream
(define (stream-get stream) (car stream))
; Retrieves the thunk and evaluates it, returning a thunk
(define (stream-next stream) ((cdr stream)))

(define (stream-ref n stream)
  (cond
    [(< n 0) (error "stream-ref: Index must be positive, got: " n)]
    [(= n 0) (stream-get stream)]
    [else (stream-ref (- n 1) (stream-next stream))]))
