#lang racket
(define (runner count thunk call-back)
  (cond [(<= count 0) (call-back (thunk) thunk)] ; invokes thunk once, and passes it to call-back
        [else (call-back count thunk)]))   ; does not invoke thunk once

(runner 10 (thunk 20) cons)
(runner 0 (thunk 20) cons)
